## lkrg-0.9.9.tar.gz

=== Makefile ===
##
# Makefile for LKRG (main branch)
#
# Author:
#  - Adam 'pi3' Zabrocki (http://pi3.com.pl)
##

P_OUTPUT = output
P_PWD ?= $(shell pwd)
P_KVER ?= $(shell uname -r)
P_BOOTUP_SCRIPT ?= scripts/bootup/lkrg-bootup.sh
TARGET := lkrg
ifneq ($(KERNELRELEASE),)
    KERNEL := /lib/modules/$(KERNELRELEASE)/build
else
    ## KERNELRELEASE not set.
    KERNEL := /lib/modules/$(P_KVER)/build
endif

#
# Use DEBUG=on for debug build.
#
ifeq ($(DEBUG), on)
ccflags-m := -ggdb -DP_LKRG_DEBUG_BUILD -finstrument-functions
ccflags-y := ${ccflags-m}
$(TARGET)-objs += src/modules/print_log/p_lkrg_debug_log.o
endif

obj-m += $(TARGET).o
$(TARGET)-objs += src/modules/ksyms/p_resolve_ksym.o \
                  src/modules/hashing/p_lkrg_fast_hash.o \
                  src/modules/comm_channel/p_comm_channel.o \
                  src/modules/integrity_timer/p_integrity_timer.o \
                  src/modules/integrity_timer/verify_kprobes/p_verify_kprobes.o \
                  src/modules/kmod/p_kmod.o \
                  src/modules/net/net.o \
                  src/modules/database/CPU.o \
                  src/modules/database/arch/x86/p_x86_metadata.o \
                  src/modules/database/arch/x86/p_switch_idt/p_switch_idt.o \
                  src/modules/database/arch/arm64/p_arm64_metadata.o \
                  src/modules/database/arch/arm/p_arm_metadata.o \
                  src/modules/database/arch/p_arch_metadata.o \
                  src/modules/database/JUMP_LABEL/p_arch_jump_label_transform/p_arch_jump_label_transform.o \
                  src/modules/database/JUMP_LABEL/p_arch_jump_label_transform_apply/p_arch_jump_label_transform_apply.o \
                  src/modules/database/FTRACE/p_ftrace_modify_all_code/p_ftrace_modify_all_code.o \
                  src/modules/database/FTRACE/p_ftrace_enable_sysctl/p_ftrace_enable_sysctl.o \
                  src/modules/database/TRACEPOINT/p_arch_static_call_transform/p_arch_static_call_transform.o \
                  src/modules/database/p_database.o \
                  src/modules/notifiers/p_notifiers.o \
                  src/modules/self-defense/hiding/p_hiding.o \
                  src/modules/exploit_detection/p_rb_ed_trees/p_rb_ed_pids/p_rb_ed_pids_tree.o \
                  src/modules/exploit_detection/syscalls/p_install.o \
                  src/modules/exploit_detection/syscalls/exec/p_security_bprm_committing_creds/p_security_bprm_committing_creds.o \
                  src/modules/exploit_detection/syscalls/exec/p_security_bprm_committed_creds/p_security_bprm_committed_creds.o \
                  src/modules/exploit_detection/syscalls/p_call_usermodehelper/p_call_usermodehelper.o \
                  src/modules/exploit_detection/syscalls/p_call_usermodehelper_exec/p_call_usermodehelper_exec.o \
                  src/modules/exploit_detection/syscalls/p_do_exit/p_do_exit.o \
                  src/modules/exploit_detection/syscalls/p_wake_up_new_task/p_wake_up_new_task.o \
                  src/modules/exploit_detection/syscalls/p_sys_setuid/p_sys_setuid.o \
                  src/modules/exploit_detection/syscalls/p_sys_setreuid/p_sys_setreuid.o \
                  src/modules/exploit_detection/syscalls/p_sys_setresuid/p_sys_setresuid.o \
                  src/modules/exploit_detection/syscalls/p_sys_setfsuid/p_sys_setfsuid.o \
                  src/modules/exploit_detection/syscalls/p_sys_setgid/p_sys_setgid.o \
                  src/modules/exploit_detection/syscalls/p_sys_setregid/p_sys_setregid.o \
                  src/modules/exploit_detection/syscalls/p_sys_setresgid/p_sys_setresgid.o \
                  src/modules/exploit_detection/syscalls/p_sys_setfsgid/p_sys_setfsgid.o \
                  src/modules/exploit_detection/syscalls/p_set_current_groups/p_set_current_groups.o \
                  src/modules/exploit_detection/syscalls/p_generic_permission/p_generic_permission.o \
                  src/modules/exploit_detection/syscalls/p_sel_write_enforce/p_sel_write_enforce.o \
                  src/modules/exploit_detection/syscalls/p_seccomp/p_seccomp.o \
                  src/modules/exploit_detection/syscalls/p_sys_unshare/p_sys_unshare.o \
                  src/modules/exploit_detection/syscalls/p_sys_setns/p_sys_setns.o \
                  src/modules/exploit_detection/syscalls/caps/p_sys_capset/p_sys_capset.o \
                  src/modules/exploit_detection/syscalls/caps/p_cap_task_prctl/p_cap_task_prctl.o \
                  src/modules/exploit_detection/syscalls/keyring/p_key_change_session_keyring/p_key_change_session_keyring.o \
                  src/modules/exploit_detection/syscalls/keyring/p_sys_add_key/p_sys_add_key.o \
                  src/modules/exploit_detection/syscalls/keyring/p_sys_request_key/p_sys_request_key.o \
                  src/modules/exploit_detection/syscalls/keyring/p_sys_keyctl/p_sys_keyctl.o \
                  src/modules/exploit_detection/syscalls/p_security_ptrace_access/p_security_ptrace_access.o \
                  src/modules/exploit_detection/syscalls/compat/p_compat_sys_keyctl/p_compat_sys_keyctl.o \
                  src/modules/exploit_detection/syscalls/compat/p_compat_sys_capset/p_compat_sys_capset.o \
                  src/modules/exploit_detection/syscalls/compat/p_compat_sys_add_key/p_compat_sys_add_key.o \
                  src/modules/exploit_detection/syscalls/compat/p_compat_sys_request_key/p_compat_sys_request_key.o \
                  src/modules/exploit_detection/syscalls/__x32/p_x32_sys_keyctl/p_x32_sys_keyctl.o \
                  src/modules/exploit_detection/syscalls/override/p_override_creds/p_override_creds.o \
                  src/modules/exploit_detection/syscalls/override/p_revert_creds/p_revert_creds.o \
                  src/modules/exploit_detection/syscalls/override/overlayfs/p_ovl_override_sync/p_ovl_override_sync.o \
                  src/modules/exploit_detection/syscalls/pCFI/p_mark_inode_dirty/p_mark_inode_dirty.o \
                  src/modules/exploit_detection/syscalls/pCFI/p_schedule/p_schedule.o \
                  src/modules/exploit_detection/syscalls/pCFI/p___queue_work/p___queue_work.o \
                  src/modules/exploit_detection/syscalls/pCFI/p_lookup_fast/p_lookup_fast.o \
                  src/modules/exploit_detection/syscalls/p_capable/p_capable.o \
                  src/modules/exploit_detection/syscalls/p_scm_send/p_scm_send.o \
                  src/modules/exploit_detection/p_selinux_state.o \
                  src/modules/exploit_detection/p_exploit_detection.o \
                  src/p_lkrg_main.o


all:
#	$(MAKE) -C $(KERNEL) M=$(P_PWD) modules CONFIG_DEBUG_SECTION_MISMATCH=y
	$(MAKE) -C $(KERNEL) M=$(P_PWD) modules
	mkdir -p $(P_OUTPUT)
	cp $(P_PWD)/$(TARGET).ko $(P_OUTPUT)

install:
	$(MAKE) -C $(KERNEL) M=$(P_PWD) modules_install
	depmod -a
	$(P_PWD)/$(P_BOOTUP_SCRIPT) install

uninstall:
	$(P_PWD)/$(P_BOOTUP_SCRIPT) uninstall

clean:
	$(MAKE) -C $(KERNEL) M=$(P_PWD) clean
	$(RM) Module.markers modules.order
	$(RM) $(P_PWD)/src/modules/kmod/client/kmod/Module.markers
	$(RM) $(P_PWD)/src/modules/kmod/client/kmod/modules.order
	$(RM) -rf $(P_OUTPUT)

=== logger/Makefile ===
CC = gcc
LD = $(CC)
RM = rm -f
MKDIR = mkdir -p
INSTALL = install -c
CFLAGS = -Wall -W -O2 -fomit-frame-pointer
LDFLAGS = -s

DESTDIR =
PREFIX = /usr/local
SBINDIR = $(PREFIX)/sbin
UNITDIR = /etc/systemd/system

PROJ = lkrg-logger lkrg-logctl lkrg-keygen
LOGGER_OBJS = logger.o misc.o session.o
LOGCTL_OBJS = logctl.o
KEYGEN_OBJS = keygen.o
OBJS = $(LOGGER_OBJS) $(LOGCTL_OBJS) $(KEYGEN_OBJS)

all: $(PROJ)

lkrg-logger: $(LOGGER_OBJS)
	$(LD) $(LDFLAGS) $(LOGGER_OBJS) -o $@

lkrg-logctl: $(LOGCTL_OBJS)
	$(LD) $(LDFLAGS) $(LOGCTL_OBJS) -o $@

lkrg-keygen: $(KEYGEN_OBJS)
	$(LD) $(LDFLAGS) $(KEYGEN_OBJS) -o $@

.c.o:
	$(CC) $(CFLAGS) -c $*.c

install: $(PROJ)
	$(MKDIR) -m 755 $(DESTDIR)$(SBINDIR)
	$(INSTALL) -m 700 lkrg-logger $(DESTDIR)$(SBINDIR)/
	$(INSTALL) -m 700 lkrg-logctl $(DESTDIR)$(SBINDIR)/
	$(INSTALL) -m 755 lkrg-keygen $(DESTDIR)$(SBINDIR)/
	if [ -d $(DESTDIR)$(UNITDIR) ]; then \
		umask 022; \
		sed "s,/usr,$(PREFIX)," lkrg-logger.service > $(DESTDIR)$(UNITDIR)/lkrg-logger.service; \
	fi

uninstall:
	$(RM) $(DESTDIR)$(SBINDIR)/lkrg-{logger,logctl,keygen} $(DESTDIR)$(UNITDIR)/lkrg-logger.service

clean:
	$(RM) $(PROJ) $(OBJS)

=== debian/changelog ===
lkrg (0.9.9-1) unstable; urgency=medium

  * New upstream release.

 -- Solar Designer <solar@openwall.com>  Wed, 23 Oct 2024 03:30:00 +0200

lkrg (0.9.8-1) unstable; urgency=medium

  * New upstream release.

 -- Solar Designer <solar@openwall.com>  Tue, 27 Feb 2024 23:30:00 +0100

lkrg (0.9.7-1) unstable; urgency=medium

  * New upstream release.

 -- Solar Designer <solar@openwall.com>  Thu, 14 Sep 2023 05:00:00 +0200

lkrg (0.9.6-1) unstable; urgency=medium

  * New upstream release.

 -- Solar Designer <solar@openwall.com>  Wed, 14 Dec 2022 17:00:00 +0100

lkrg (0.9.5-1) unstable; urgency=medium

  * New upstream release.

 -- Solar Designer <solar@openwall.com>  Mon,  1 Aug 2022 13:15:00 +0200

lkrg (0.9.4-1) unstable; urgency=medium

  * New upstream release.
  * debian/lkrg-dkms.*:
    + Rename the module from p_lkrg to lkrg.

 -- Solar Designer <solar@openwall.com>  Fri, 22 Jul 2022 19:20:00 +0200

lkrg (0.9.3-1) unstable; urgency=medium

  * New upstream release.

 -- Solar Designer <solar@openwall.com>  Thu, 21 Apr 2022 15:00:00 +0200

lkrg (0.9.2-1) unstable; urgency=medium

  * New upstream release.
  * debian/rules:
    + Install the sysctl settings in /etc/sysctl.d/01-lkrg.conf.

 -- Solar Designer <solar@openwall.com>  Tue, 28 Dec 2021 23:59:59 +0100

lkrg (0.9.1-2) unstable; urgency=medium

  * Drop the debian/lkrg-dkms.sysctl file altogether and use the provided
    scripts/bootup/lkrg.conf file instead.

 -- Mikhail Morfikov <mmorfikov@gmail.com>  Tue, 18 May 2021 19:27:18 +0200

lkrg (0.9.1-1) unstable; urgency=medium

  * New upstream release.
  * debian/copyright:
    + Add missing copyrights.
  * debian/lkrg-dkms.sysctl:
    + Add the LKRG sysctl documentation.

 -- Mikhail Morfikov <mmorfikov@gmail.com>  Tue, 27 Apr 2021 20:11:24 +0200

lkrg (0.9.0-1) unstable; urgency=medium

  * Initial Release (Closes: #944476)

 -- Mikhail Morfikov <mmorfikov@gmail.com>  Tue, 13 Apr 2021 20:13:07 +0200

=== debian/control ===
Source: lkrg
Section: kernel
Priority: optional
Maintainer: Mikhail Morfikov <mmorfikov@gmail.com>
Homepage: https://lkrg.org
Vcs-Browser: https://github.com/lkrg-org/lkrg
Vcs-Git: https://github.com/lkrg-org/lkrg.git
Standards-Version: 4.5.1.1
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13),
 dh-dkms

Package: lkrg
Architecture: all
Depends: ${misc:Depends},
 lkrg-dkms (= ${source:Version})
Description: Linux Kernel Runtime Guard (LKRG)
 LKRG performs runtime integrity checking of the Linux kernel and detection of
 security vulnerability exploits against the kernel.
 .
 LKRG is a kernel module (not a kernel patch), so it can be built for and loaded
 on top of a wide range of mainline and distros' kernels, without needing to
 patch those.
 .
 That is only a dependency package to install the LKRG kernel module and also
 some systemd service in order to help to manage loading/unloading the module at
 system boot/shutdown.

Package: lkrg-dkms
Architecture: all
Depends: ${misc:Depends},
 dkms
Recommends: lkrg-systemd (= ${source:Version})
Description: Linux Kernel Runtime Guard (LKRG) Source Code and DKMS
 LKRG performs runtime integrity checking of the Linux kernel and detection of
 security vulnerability exploits against the kernel.
 .
 LKRG is a kernel module (not a kernel patch), so it can be built for and loaded
 on top of a wide range of mainline and distros' kernels, without needing to
 patch those.
 .
 This package uses DKMS to automatically build the LKRG kernel module.

Package: lkrg-systemd
Architecture: all
Depends: ${misc:Depends},
 lkrg-dkms (= ${source:Version}),
 systemd
Description: Systemd integration for Linux Kernel Runtime Guard (LKRG)
 LKRG performs runtime integrity checking of the Linux kernel and detection of
 security vulnerability exploits against the kernel.
 .
 LKRG is a kernel module (not a kernel patch), so it can be built for and loaded
 on top of a wide range of mainline and distros' kernels, without needing to
 patch those.
 .
 This package provides systemd integration for the LKRG kernel module.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1
export DH_OPTIONS = -v
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk

%:
	dh $@ --with dkms

override_dh_install:
	dh_install -p lkrg-dkms    scripts/ usr/src/$(DEB_SOURCE)-$(DEB_VERSION_UPSTREAM)
	dh_install -p lkrg-dkms    src/ usr/src/$(DEB_SOURCE)-$(DEB_VERSION_UPSTREAM)
	dh_install -p lkrg-dkms    Makefile usr/src/$(DEB_SOURCE)-$(DEB_VERSION_UPSTREAM)
	dh_install -p lkrg-systemd scripts/bootup/systemd/lkrg.service lib/systemd/system
	mkdir -p debian/tmp/etc/sysctl.d
	mkdir -p debian/tmp/etc/modules-load.d
	cp scripts/bootup/lkrg.conf debian/tmp/etc/sysctl.d/01-lkrg.conf
	cp debian/lkrg-dkms.modules debian/tmp/etc/modules-load.d/lkrg-dkms.conf
	dh_install -p lkrg-dkms    debian/tmp/etc/sysctl.d/01-lkrg.conf etc/sysctl.d
	dh_install -p lkrg-dkms    debian/tmp/etc/modules-load.d/lkrg-dkms.conf etc/modules-load.d

override_dh_dkms:
	dh_dkms -V $(DEB_VERSION_UPSTREAM)

override_dh_auto_configure:
override_dh_auto_build:
override_dh_auto_test:
override_dh_auto_install:
override_dh_auto_clean:

override_dh_installsystemd:
	dh_installsystemd --no-enable --no-stop-on-upgrade

override_dh_missing:
	dh_missing --list-missing --fail-missing

=== debian/watch ===
version=4
https://lkrg.org/download/lkrg-(.+).tar.gz
opts=pgpsigurlmangle=s/$/.sign/ https://lkrg.org/download/lkrg-(.+).tar.gz
